
Redmine - Defect #8696

undefined method `<<' for nil:NilClass during 1.1.2 to 1.2.0 upgrade

2011-06-27 17:32 - Mathieu MARACHE

Status: Closed Start date: 2011-06-03

Priority: Normal Due date:  

Assignee:  % Done: 100%

Category:  Estimated time: 0.00 hour

Target version:    

Resolution: Invalid Affected version: 1.2.0

Description

I duplicated the bug #8521 because I have the same exact issue but from 1.1.2 and the "solution" given in the feedback (repeating

upgrade steps) did not work for me.

Got this error undefined method `<<' for nil:NilClass after during database upgrade with the command: rake db:migrate

RAILS_ENV=production

@$ rake --trace db:migrate RAILS_ENV=production

(in /srv/gitosis/redmine)

Invoke db:migrate (first_time)

Invoke environment (first_time)

Execute environment

Execute db:migrate

AddWorkflowsAssigneeAndAuthor: migrating ================================

-- add_column(:workflows, :assignee, :boolean, {:null=>false, :default=>false})

 > 0.3382s

- add_column(:workflows, :author, :boolean, {:null=>false, :default=>false})

-> 0.0948s

AddWorkflowsAssigneeAndAuthor: migrated (0.5401s) =======================

AddUsersSalt: migrating =================================================

-- add_column(:users, :salt, :string, {:limit=>64})

-> 0.0732s

AddUsersSalt: migrated (0.0735s) ========================================    SaltUserPasswords: migrating

============================================

-- Salting user passwords, this may take some time...

-> 0.0698s

SaltUserPasswords: migrated (0.0700s) ===================================    AddRepositoriesPathEncoding: migrating

==================================

-- add_column(:repositories, :path_encoding, :string, {:limit=>64, :default=>nil})

-> 0.1148s

AddRepositoriesPathEncoding: migrated (0.1151s) =========================    ChangeRepositoriesPasswordLimit: migrating

==============================

-- change_column(:repositories, :password, :string, {:limit=>nil, :default=>""})

-> 0.1507s

ChangeRepositoriesPasswordLimit: migrated (0.1510s) =====================    ChangeAuthSourcesAccountPasswordLimit:

migrating ========================

-- change_column(:auth_sources, :account_password, :string, {:limit=>nil, :default=>""})

-> 0.0936s

ChangeAuthSourcesAccountPasswordLimit: migrated (0.0939s) ===============    ChangeJournalDetailsValuesToText:

migrating =============================

-- change_column(:journal_details, :old_value, :text)

 > 0.1625s

- change_column(:journal_details, :value, :text)

-> 0.1164s

ChangeJournalDetailsValuesToText: migrated (0.2797s) ====================    AddRepositoriesLogEncoding: migrating

===================================

-- add_column(:repositories, :log_encoding, :string, {:limit=>64, :default=>nil})

-> 0.0701s

AddRepositoriesLogEncoding: migrated (0.0705s) ==========================    CopyRepositoriesLogEncoding: migrating

==================================
rake aborted!

An error has occurred, all later migrations canceled:   

undefined method `<<' for nil:NilClass

/srv/gitosis/redmine/vendor/plugins/redmine_gitosis/app/models/gitosis_observer.rb:32:in `projects_need_update'

/srv/gitosis/redmine/vendor/plugins/redmine_gitosis/app/models/gitosis_observer.rb:20:in `update_repositories'

/srv/gitosis/redmine/vendor/plugins/redmine_gitosis/app/models/gitosis_observer.rb:13:in `after_save'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/observer.rb:171:in `send'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/observer.rb:171:in `update'

/usr/lib/ruby/1.8/observer.rb:185:in `notify_observers'

/usr/lib/ruby/1.8/observer.rb:184:in `each'

/usr/lib/ruby/1.8/observer.rb:184:in `notify_observers'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/callbacks.rb:357:in `notify'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/callbacks.rb:350:in `callback'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/callbacks.rb:251:in `create_or_update'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/base.rb:2577:in `save_without_validation'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/validations.rb:1090:in `save_without_dirty'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/dirty.rb:79:in `save_without_transactions'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/transactions.rb:229:in `send'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/transactions.rb:229:in `with_transaction_returning_status'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/connection_adapters/abstract/database_statements.rb:136:in

`transaction'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/transactions.rb:182:in `transaction'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/transactions.rb:228:in `with_transaction_returning_status'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/transactions.rb:196:in `save'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/transactions.rb:208:in `rollback_active_record_state!'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/transactions.rb:196:in `save'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/base.rb:2661:in `update_attribute'

./db/migrate//20110228000100_copy_repositories_log_encoding.rb:9:in `up_without_benchmarks'

./db/migrate//20110228000100_copy_repositories_log_encoding.rb:5:in `each'

./db/migrate//20110228000100_copy_repositories_log_encoding.rb:5:in `up_without_benchmarks'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/migration.rb:282:in `send'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/migration.rb:282:in `migrate'

/usr/lib/ruby/1.8/benchmark.rb:293:in `measure'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/migration.rb:282:in `migrate'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/migration.rb:365:in `__send__'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/migration.rb:365:in `migrate'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/migration.rb:491

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/migration.rb:567:in `call'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/migration.rb:567:in `ddl_transaction'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/migration.rb:490:in `migrate'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/migration.rb:477:in `each'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/migration.rb:477:in `migrate'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/migration.rb:401:in `up'

/var/lib/gems/1.8/gems/activerecord-2.3.11/lib/active_record/migration.rb:383:in `migrate'

/var/lib/gems/1.8/gems/rails-2.3.11/lib/tasks/databases.rake:112

/var/lib/gems/1.8/gems/rake-0.8.3/lib/rake.rb:617:in `call'

/var/lib/gems/1.8/gems/rake-0.8.3/lib/rake.rb:617:in `execute'

/var/lib/gems/1.8/gems/rake-0.8.3/lib/rake.rb:612:in `each'

/var/lib/gems/1.8/gems/rake-0.8.3/lib/rake.rb:612:in `execute'

/var/lib/gems/1.8/gems/rake-0.8.3/lib/rake.rb:578:in `invoke_with_call_chain'

/usr/lib/ruby/1.8/monitor.rb:242:in `synchronize'

/var/lib/gems/1.8/gems/rake-0.8.3/lib/rake.rb:571:in `invoke_with_call_chain'

/var/lib/gems/1.8/gems/rake-0.8.3/lib/rake.rb:564:in `invoke'

/var/lib/gems/1.8/gems/rake-0.8.3/lib/rake.rb:2019:in `invoke_task'

/var/lib/gems/1.8/gems/rake-0.8.3/lib/rake.rb:1997:in `top_level'

/var/lib/gems/1.8/gems/rake-0.8.3/lib/rake.rb:1997:in `each'

/var/lib/gems/1.8/gems/rake-0.8.3/lib/rake.rb:1997:in `top_level'

/var/lib/gems/1.8/gems/rake-0.8.3/lib/rake.rb:2036:in `standard_exception_handling'

/var/lib/gems/1.8/gems/rake-0.8.3/lib/rake.rb:1991:in `top_level'

/var/lib/gems/1.8/gems/rake-0.8.3/lib/rake.rb:1970:in `run'

/var/lib/gems/1.8/gems/rake-0.8.3/lib/rake.rb:2036:in `standard_exception_handling'

/var/lib/gems/1.8/gems/rake-0.8.3/lib/rake.rb:1967:in `run'

/var/lib/gems/1.8/gems/rake-0.8.3/bin/rake:31

/var/lib/gems/1.8/bin/rake:19:in `load'

/var/lib/gems/1.8/bin/rake:19@
$ gem environment

RubyGems Environment:

- RUBYGEMS VERSION: 1.3.7

- RUBY VERSION: 1.8.7 (2010-01-10 patchlevel 249) [i486-linux]

- INSTALLATION DIRECTORY: /var/lib/gems/1.8

- RUBY EXECUTABLE: /usr/bin/ruby1.8

- EXECUTABLE DIRECTORY: /var/lib/gems/1.8/bin

- RUBYGEMS PLATFORMS:

- ruby

- x86-linux

- GEM PATHS:

- /var/lib/gems/1.8

- /home/marache/.gem/ruby/1.8

- GEM CONFIGURATION:

- :update_sources => true

- :verbose => true

- :benchmark => false

- :backtrace => false

- :bulk_threshold => 1000

- REMOTE SOURCES:

- http://rubygems.org/

@$ gem list

LOCAL GEMS ***

actionmailer (2.3.11, 2.3.5)

actionpack (2.3.11, 2.3.5)

activerecord (2.3.11, 2.3.5)

activeresource (2.3.11, 2.3.5)

activesupport (2.3.11, 2.3.5)

crack (0.1.8)

daemon_controller (0.2.6)

fastercsv (1.5.4)

fastthread (1.0.7)

file-tail (1.0.5)

googlecharts (1.6.1)

holidays (1.0.0)

httparty (0.7.7)

i18n (0.5.0, 0.4.2)

icalendar (1.1.6)

inifile (0.4.1)

lockfile (1.4.3)

mini_magick (3.2)

mysql (2.8.1)

net-ssh (2.1.3)

passenger (3.0.5)

prawn (0.8.4)

prawn-core (0.8.4)

prawn-layout (0.8.4)

prawn-security (0.8.4)

rack (1.1.2, 1.1.1, 1.0.1)

rails (2.3.11, 2.3.5)

rake (0.8.3)

rmagick (2.13.1)

spruz (0.2.5)

subexec (0.0.4)

svn2git (2.1.0, 2.0.0)@

History

#1 - 2011-06-27 17:39 - Etienne Massip

Try removing redmine_gitosis plugin, running RM migrations then restoring plugin and running plugins migrations.

#2 - 2011-06-27 18:26 - Mathieu MARACHE

- Status changed from New to Resolved
- % Done changed from 0 to 100

That was fast and accurate :-) thanks for the lightning speed

#3 - 2011-06-27 19:19 - Etienne Massip

- Status changed from Resolved to Closed

You're welcome.
